"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Copyright 2025, Pulumi Corporation.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
"""
import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import google.protobuf.struct_pb2
import pulumi.provider_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing_extensions.final
class PublishViewStepsRequest(google.protobuf.message.Message):
    """`PublishViewStepsRequest` is the type of requests sent as part of a
    [](pulumirpc.ResourceStatus.PublishViewSteps) call.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TOKEN_FIELD_NUMBER: builtins.int
    STEPS_FIELD_NUMBER: builtins.int
    token: builtins.str
    """The service context token."""
    @property
    def steps(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ViewStep]:
        """The steps to publish."""
    def __init__(
        self,
        *,
        token: builtins.str = ...,
        steps: collections.abc.Iterable[global___ViewStep] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["steps", b"steps", "token", b"token"]) -> None: ...

global___PublishViewStepsRequest = PublishViewStepsRequest

@typing_extensions.final
class PublishViewStepsResponse(google.protobuf.message.Message):
    """`PublishViewStepsResponse` is the type of responses sent as part of a
    [](pulumirpc.ResourceStatus.PublishViewSteps) call.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___PublishViewStepsResponse = PublishViewStepsResponse

@typing_extensions.final
class ViewStep(google.protobuf.message.Message):
    """`ViewStep` represents a deployment operation step for a view resource."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class _Op:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _OpEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[ViewStep._Op.ValueType], builtins.type):  # noqa: F821
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        UNSPECIFIED: ViewStep._Op.ValueType  # 0
        """An unspecified operation."""
        SAME: ViewStep._Op.ValueType  # 1
        """Nothing to do."""
        CREATE: ViewStep._Op.ValueType  # 2
        """Creating a new resource."""
        UPDATE: ViewStep._Op.ValueType  # 3
        """Updating an existing resource."""
        DELETE: ViewStep._Op.ValueType  # 4
        """Deleting an existing resource."""
        REPLACE: ViewStep._Op.ValueType  # 5
        """Replacing a resource with a new one."""
        CREATE_REPLACEMENT: ViewStep._Op.ValueType  # 6
        """Creating a new resource for a replacement."""
        DELETE_REPLACED: ViewStep._Op.ValueType  # 7
        """Deleting an existing resource after replacement."""
        READ: ViewStep._Op.ValueType  # 8
        """Reading an existing resource."""
        READ_REPLACEMENT: ViewStep._Op.ValueType  # 9
        """Reading an existing resource for a replacement."""
        REFRESH: ViewStep._Op.ValueType  # 10
        """Refreshing an existing resource."""
        READ_DISCARD: ViewStep._Op.ValueType  # 11
        """Removing a resource that was read."""
        DISCARD_REPLACED: ViewStep._Op.ValueType  # 12
        """Discarding a read resource that was replaced."""
        REMOVE_PENDING_REPLACE: ViewStep._Op.ValueType  # 13
        """Removing a pending replace resource."""
        IMPORT: ViewStep._Op.ValueType  # 14
        """Import an existing resource."""
        IMPORT_REPLACEMENT: ViewStep._Op.ValueType  # 15
        """Replace an existing resource."""

    class Op(_Op, metaclass=_OpEnumTypeWrapper):
        """Represents the kind of operation performed by a step."""

    UNSPECIFIED: ViewStep.Op.ValueType  # 0
    """An unspecified operation."""
    SAME: ViewStep.Op.ValueType  # 1
    """Nothing to do."""
    CREATE: ViewStep.Op.ValueType  # 2
    """Creating a new resource."""
    UPDATE: ViewStep.Op.ValueType  # 3
    """Updating an existing resource."""
    DELETE: ViewStep.Op.ValueType  # 4
    """Deleting an existing resource."""
    REPLACE: ViewStep.Op.ValueType  # 5
    """Replacing a resource with a new one."""
    CREATE_REPLACEMENT: ViewStep.Op.ValueType  # 6
    """Creating a new resource for a replacement."""
    DELETE_REPLACED: ViewStep.Op.ValueType  # 7
    """Deleting an existing resource after replacement."""
    READ: ViewStep.Op.ValueType  # 8
    """Reading an existing resource."""
    READ_REPLACEMENT: ViewStep.Op.ValueType  # 9
    """Reading an existing resource for a replacement."""
    REFRESH: ViewStep.Op.ValueType  # 10
    """Refreshing an existing resource."""
    READ_DISCARD: ViewStep.Op.ValueType  # 11
    """Removing a resource that was read."""
    DISCARD_REPLACED: ViewStep.Op.ValueType  # 12
    """Discarding a read resource that was replaced."""
    REMOVE_PENDING_REPLACE: ViewStep.Op.ValueType  # 13
    """Removing a pending replace resource."""
    IMPORT: ViewStep.Op.ValueType  # 14
    """Import an existing resource."""
    IMPORT_REPLACEMENT: ViewStep.Op.ValueType  # 15
    """Replace an existing resource."""

    class _Status:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _StatusEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[ViewStep._Status.ValueType], builtins.type):  # noqa: F821
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        OK: ViewStep._Status.ValueType  # 0
        PARTIAL_FAILURE: ViewStep._Status.ValueType  # 1
        UNKNOWN: ViewStep._Status.ValueType  # 2

    class Status(_Status, metaclass=_StatusEnumTypeWrapper):
        """Status is returned when an error has occurred during a resource provider operation.
        It indicates whether the operation could be rolled back cleanly (OK). If not, it
        means the resource was left in an indeterminate state.
        """

    OK: ViewStep.Status.ValueType  # 0
    PARTIAL_FAILURE: ViewStep.Status.ValueType  # 1
    UNKNOWN: ViewStep.Status.ValueType  # 2

    @typing_extensions.final
    class DetailedDiffEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> pulumi.provider_pb2.PropertyDiff: ...
        def __init__(
            self,
            *,
            key: builtins.str = ...,
            value: pulumi.provider_pb2.PropertyDiff | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing_extensions.Literal["value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing_extensions.Literal["key", b"key", "value", b"value"]) -> None: ...

    STATUS_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    OP_FIELD_NUMBER: builtins.int
    TYPE_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    OLD_FIELD_NUMBER: builtins.int
    NEW_FIELD_NUMBER: builtins.int
    KEYS_FIELD_NUMBER: builtins.int
    DIFFS_FIELD_NUMBER: builtins.int
    DETAILED_DIFF_FIELD_NUMBER: builtins.int
    HAS_DETAILED_DIFF_FIELD_NUMBER: builtins.int
    status: global___ViewStep.Status.ValueType
    """The status of the operation."""
    error: builtins.str
    """An optional error message indicating the operation failed."""
    op: global___ViewStep.Op.ValueType
    """The operation being performed."""
    type: builtins.str
    """The type of the view resource."""
    name: builtins.str
    """The name of the view resource."""
    @property
    def old(self) -> global___ViewStepState:
        """The state of the view resource before performing the step."""
    @property
    def new(self) -> global___ViewStepState:
        """The state of the view resource after performing the step."""
    @property
    def keys(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """The keys causing a replacement (only applicable for "create" and "replace" ops)."""
    @property
    def diffs(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """The keys that changed with this step."""
    @property
    def detailed_diff(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, pulumi.provider_pb2.PropertyDiff]:
        """A detailed diff is a map from [property paths](property-paths) to [](pulumirpc.PropertyDiff)s,
        which describe the kind of change that occurred to the property located at that path.
        """
    has_detailed_diff: builtins.bool
    """Whether the detailed diff is present."""
    def __init__(
        self,
        *,
        status: global___ViewStep.Status.ValueType = ...,
        error: builtins.str = ...,
        op: global___ViewStep.Op.ValueType = ...,
        type: builtins.str = ...,
        name: builtins.str = ...,
        old: global___ViewStepState | None = ...,
        new: global___ViewStepState | None = ...,
        keys: collections.abc.Iterable[builtins.str] | None = ...,
        diffs: collections.abc.Iterable[builtins.str] | None = ...,
        detailed_diff: collections.abc.Mapping[builtins.str, pulumi.provider_pb2.PropertyDiff] | None = ...,
        has_detailed_diff: builtins.bool = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["new", b"new", "old", b"old"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["detailed_diff", b"detailed_diff", "diffs", b"diffs", "error", b"error", "has_detailed_diff", b"has_detailed_diff", "keys", b"keys", "name", b"name", "new", b"new", "old", b"old", "op", b"op", "status", b"status", "type", b"type"]) -> None: ...

global___ViewStep = ViewStep

@typing_extensions.final
class ViewStepState(google.protobuf.message.Message):
    """`ViewStepState` represents the state of a view resource."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TYPE_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    PARENT_TYPE_FIELD_NUMBER: builtins.int
    PARENT_NAME_FIELD_NUMBER: builtins.int
    INPUTS_FIELD_NUMBER: builtins.int
    OUTPUTS_FIELD_NUMBER: builtins.int
    type: builtins.str
    """The type of the view resource."""
    name: builtins.str
    """The name of the view resource."""
    parent_type: builtins.str
    """An optional type of the parent view resource. By default, a view resource will
    be a child of the owning resource, but views can be nested within other views,
    as long as they're all under the same owner. Both parent_type and parent_name
    must be set together.
    """
    parent_name: builtins.str
    """An optional name of the parent view resource. By default, a view resource will
    be a child of the owning resource, but views can be nested within other views,
    as long as they're all under the same owner. Both parent_type and parent_name
    must be set together.
    """
    @property
    def inputs(self) -> google.protobuf.struct_pb2.Struct:
        """The view resource's inputs."""
    @property
    def outputs(self) -> google.protobuf.struct_pb2.Struct:
        """The view resource's outputs."""
    def __init__(
        self,
        *,
        type: builtins.str = ...,
        name: builtins.str = ...,
        parent_type: builtins.str = ...,
        parent_name: builtins.str = ...,
        inputs: google.protobuf.struct_pb2.Struct | None = ...,
        outputs: google.protobuf.struct_pb2.Struct | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["inputs", b"inputs", "outputs", b"outputs"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["inputs", b"inputs", "name", b"name", "outputs", b"outputs", "parent_name", b"parent_name", "parent_type", b"parent_type", "type", b"type"]) -> None: ...

global___ViewStepState = ViewStepState
